
/*#include "matopt_110929.c"*/

void Lindstrom(double *Y, double *Y_new, double *Z, double *mu,
	double *Lamb, double *SIG, double *sdt_NR, double *para, double alpha, double *X, double *XV, int NX, int NXV,
	int NObs, int *N0_ALL, int **obsloc , int N1, int NLat, int Npara,
	int FL, int *ACCy, int *ACCy_bs, long *idum)
{
	int iNObs1, iNObs2, iNObs3;
	int jN01, jN2, jN1;
	int kNLat1;
	int lNR1;
	/*int n1;*/
	int itmp;
	int NRYstart, NRYcur, NRdtstart;
	
	int N0, N1m1=N1-1;
	
	double *a, *b, *mu_lind;
	double *P, *K, *L, *SIGMA0, *SIGMA;
	double *y_new, *y_old;
	
	double dtmp;
	
	double prop_new, prop_old, proptmp;
	double like_new, like_old;
	
	double *Xcur;
	double *XVcur0, *XVcur1, *XVcur;
	
	int NR;
	
	a = (double *) mxMalloc(sizeof(double) * NLat);
	b = (double *) mxMalloc(sizeof(double) * NLat);    
	mu_lind = (double *) mxMalloc(sizeof(double) * NLat);    
	P = (double *) mxMalloc(sizeof(double) * NLat * NLat);    
	K = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	L = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	SIGMA = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	SIGMA0 = (double *) mxMalloc(sizeof(double) * NLat * NLat);
	y_new = (double *) mxMalloc(sizeof(double) * NLat);
	y_old = (double *) mxMalloc(sizeof(double) * NLat);
	
	
	vb_eqn_va(Y, Y_new, NObs*N1*NLat);
	
	/*sdt_NR is a N1 * NObs vector*/
	for (iNObs1 = 0; iNObs1 < NObs; iNObs1++) {
		N0 = N0_ALL[iNObs1];
		iNObs2 = iNObs1 * N1 * NLat; 
		iNObs3 = iNObs1 * N1;  /*not N1-1*/
		
		Xcur=X+iNObs1*NX;
		XVcur0 = XV + iNObs1 * N1m1 * NXV;
		
		for (jN01 = 0; jN01 < N0; jN01++) {
			/* ***
			jN1 = jN01 * (NR + 1);
			*/
			jN1 = obsloc[iNObs1][jN01];
			
			jN2 = jN1*NLat;
			prop_new=0;
			prop_old=0;
			NRYstart = iNObs2 + jN2;
			NRdtstart = iNObs3 + jN1;
			
			NR = obsloc[iNObs1][jN01+1] - obsloc[iNObs1][jN01] -1;
			
			XVcur1 = XVcur0 + jN1 * NXV;
			
			for (lNR1 = 1; lNR1 <= NR; lNR1++) {
				NRYcur = NRYstart + lNR1 * NLat;
				/*XVcur = XVcur1 + (lNR1-1) * NXV;*/
				/*modified brownian bridga 1st order proposal*/
				Lindstrom_1step(Y_new + NRYstart, sdt_NR + NRdtstart, para, a, b, mu_lind, P, K, L, SIGMA, SIGMA0, y_new, alpha, &proptmp, Xcur, XVcur1, lNR1, NLat, NXV, NR,  FL, 1, 1, idum);
				vb_eqn_va(y_new, Y_new + NRYcur, NLat);				
				prop_new+=proptmp;
				
				vb_eqn_va(Y + NRYcur, y_new, NLat);	
				Lindstrom_1step(Y + NRYstart, sdt_NR + NRdtstart, para, a, b, mu_lind, P, K, L, SIGMA, SIGMA0, y_new, alpha, &proptmp, Xcur, XVcur1, lNR1, NLat, NXV, NR,  FL, 0, 1, idum);	
				prop_old+=proptmp;		
				/*mexPrintf("%d-th individual, %d-th time, %d-th interpolate.....\n", iNObs1, jN01, lNR1);*/
			}
			/*likelihood*/

			like_new = EM_diagcov(Y_new + NRYstart, sdt_NR + NRdtstart, para, Xcur, XVcur1, (NR+2), NLat,NXV);
			like_old = EM_diagcov(Y + NRYstart, sdt_NR + NRdtstart, para, Xcur, XVcur1, (NR+2), NLat,NXV);

			
			dtmp=log(ran2(idum));
			if(dtmp <= like_new+prop_old-like_old-prop_new){
				vb_eqn_va(Y_new + NRYstart, Y + NRYstart, NLat*(NR+2));
				
				for (lNR1 = 1; lNR1 <= NR; lNR1++) {
					itmp=NRYstart + lNR1 * NLat;
					for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {					
						ACCy[itmp+kNLat1]+=1;
					}
				}
				
			}else{
				vb_eqn_va(Y+NRYstart, Y_new+NRYstart, NLat*(NR+2));
			}
			
			ACCy_bs[iNObs1+jN01*NObs] +=1;
			
		}
		
		
	}
	
	mxFree(y_old);
	mxFree(y_new);
	mxFree(SIGMA0);
	mxFree(SIGMA);
	mxFree(L);
	mxFree(K);
	mxFree(P);	
	mxFree(mu_lind);
	mxFree(b);
	mxFree(a);
	
	
	
}

