/*typedef double driftf(double *, double *);
typedef double diffuf(double *, double *);*/


void MA_mul_MB();
void MA_add_MB();
void MA_mul_vb();
void va_add_vb();
void va_minus_vb();
void ivv();
void ivv1();
void ivv2();
double vaT_mul_vb();
void vb_eqn_va();
void printmatrix(double *M, int NR, int NC);

void band_choldc_c(double  *Q, double *L, int *pn, int *pp)
/*Cholesky decompposition of matrix Q to be stored in L.
Q---original matrix;
L---Cholesky decomposition in lower triangular including diagonal part;
n---dimension of matrix; pp--bandwith of matrix*/
{
	int i,j,k,l,m;
	int n,p;
	double *v;
	double sv;
	
	n=*pn;
	p=*pp;
	
	
	v=(double *) mxMalloc(sizeof(double) * n);
	
	for(j=0; j<n; j++){
		for(k=0;k<n;k++)L[j*n+k]=0.0;
		l=imin2(j+p,n-1);
		for(k=j;k<=l;k++)v[k]=Q[j*n+k];
		for(k=imax2(0,j-p);k<=j-1;k++){
			i=imin2(k+p,n-1);
			for(m=j;m<=i;m++)
				v[m]-=L[k*n+m]*L[k*n+j];
		}
		if(v[j]<=0.0){
			mexPrintf("choldc failed\n");			
			break;
		}
		sv=sqrt(v[j]);
		for(k=j;k<=l;k++){
			L[j*n+k]=v[k]/sv;
		}
	}
	mxFree(v);
}


int band_choldc_c_ind(double  *Q, double *L, int *pn, int *pp)
/*Cholesky decompposition of matrix Q to be stored in L.
Q---original matrix;
L---Cholesky decomposition in lower triangular including diagonal part;
n---dimension of matrix; pp--bandwith of matrix*/
{
	int i,j,k,l,m;
	int ind=0;
	int n,p;
	double *v;
	double sv;
	
	n=*pn;
	p=*pp;
	
	
	v=(double *) mxMalloc(sizeof(double) * n);
	
	for(j=0; j<n; j++){
		for(k=0;k<n;k++)L[j*n+k]=0.0;
		l=imin2(j+p,n-1);
		for(k=j;k<=l;k++)v[k]=Q[j*n+k];
		for(k=imax2(0,j-p);k<=j-1;k++){
			i=imin2(k+p,n-1);
			for(m=j;m<=i;m++)
				v[m]-=L[k*n+m]*L[k*n+j];
		}
		if(v[j]<=0.0){
			/*mexPrintf("choldc failed\n");*/
			ind=1;
			break;
		}
		sv=sqrt(v[j]);
		for(k=j;k<=l;k++){
			L[j*n+k]=v[k]/sv;
		}
	}
	mxFree(v);
	
	return ind;
}


void band_choldc_c_ivv(double  *Q, double *L, int *pn, int *pp)
/*Cholesky decompposition of matrix Q to be stored in L.
Q---original matrix;
L---Cholesky decomposition in lower triangular including diagonal part;
n---dimension of matrix; pp--bandwith of matrix*/
{
	int i,j,k,l,m;
	int n,p;
	double *v;
	double sv;
	
	n=*pn;
	p=*pp;
	
	
	v=(double *) mxMalloc(sizeof(double) * n);
	
	for(j=0; j<n; j++){
		for(k=0;k<n;k++)L[j*n+k]=0.0;
		l=imin2(j+p,n-1);
		for(k=j;k<=l;k++)v[k]=Q[j*n+k];
		for(k=imax2(0,j-p);k<=j-1;k++){
			i=imin2(k+p,n-1);
			for(m=j;m<=i;m++)
				v[m]-=L[k*n+m]*L[k*n+j];
		}
		if(v[j]<=0.0){
			mexPrintf("choldc ivv failed\n");
			printmatrix(Q,n,n);
		}
		sv=sqrt(v[j]);
		for(k=j;k<=l;k++){
			L[j*n+k]=v[k]/sv;
		}
	}
	mxFree(v);
}


void band_choldc_c_ivv1(double  *Q, double *L, int *pn, int *pp)
/*Cholesky decompposition of matrix Q to be stored in L.
Q---original matrix;
L---Cholesky decomposition in lower triangular including diagonal part;
n---dimension of matrix; pp--bandwith of matrix*/
{
	int i,j,k,l,m;
	int n,p;
	double *v;
	double sv;
	
	n=*pn;
	p=*pp;
	
	
	v=(double *) mxMalloc(sizeof(double) * n);
	
	for(j=0; j<n; j++){
		for(k=0;k<n;k++)L[j*n+k]=0.0;
		l=imin2(j+p,n-1);
		for(k=j;k<=l;k++)v[k]=Q[j*n+k];
		for(k=imax2(0,j-p);k<=j-1;k++){
			i=imin2(k+p,n-1);
			for(m=j;m<=i;m++)
				v[m]-=L[k*n+m]*L[k*n+j];
		}
		if(v[j]<=0.0){
			mexPrintf("choldc ivv1 failed\n");
			printmatrix(Q,n,n);
		}
		sv=sqrt(v[j]);
		for(k=j;k<=l;k++){
			L[j*n+k]=v[k]/sv;
		}
	}
	mxFree(v);
}



void band_choldc_c_ivv2(double  *Q, double *L, int *pn, int *pp)
/*Cholesky decompposition of matrix Q to be stored in L.
Q---original matrix;
L---Cholesky decomposition in lower triangular including diagonal part;
n---dimension of matrix; pp--bandwith of matrix*/
{
	int i,j,k,l,m;
	int n,p;
	double *v;
	double sv;
	
	n=*pn;
	p=*pp;
	
	
	v=(double *) mxMalloc(sizeof(double) * n);
	
	for(j=0; j<n; j++){
		for(k=0;k<n;k++)L[j*n+k]=0.0;
		l=imin2(j+p,n-1);
		for(k=j;k<=l;k++)v[k]=Q[j*n+k];
		for(k=imax2(0,j-p);k<=j-1;k++){
			i=imin2(k+p,n-1);
			for(m=j;m<=i;m++)
				v[m]-=L[k*n+m]*L[k*n+j];
		}
		if(v[j]<=0.0){
			mexPrintf("choldc ivv2 failed\n");
			printmatrix(Q,n,n);
		}
		sv=sqrt(v[j]);
		for(k=j;k<=l;k++){
			L[j*n+k]=v[k]/sv;
		}
	}
	mxFree(v);
}


void band_choldc_c_mvrnorm(double  *Q, double *L, int *pn, int *pp)
/*Cholesky decompposition of matrix Q to be stored in L.
Q---original matrix;
L---Cholesky decomposition in lower triangular including diagonal part;
n---dimension of matrix; pp--bandwith of matrix*/
{
	int i,j,k,l,m;
	int n,p;
	double *v;
	double sv;
	
	n=*pn;
	p=*pp;
	
	
	v=(double *) mxMalloc(sizeof(double) * n);
	
	for(j=0; j<n; j++){
		for(k=0;k<n;k++)L[j*n+k]=0.0;
		l=imin2(j+p,n-1);
		for(k=j;k<=l;k++)v[k]=Q[j*n+k];
		for(k=imax2(0,j-p);k<=j-1;k++){
			i=imin2(k+p,n-1);
			for(m=j;m<=i;m++)
				v[m]-=L[k*n+m]*L[k*n+j];
		}
		if(v[j]<=0.0)mexPrintf("choldc mvrnorm failed\n");
		sv=sqrt(v[j]);
		for(k=j;k<=l;k++){
			L[j*n+k]=v[k]/sv;
		}
	}
	mxFree(v);
}

void forward_sol_c(double *L, double *x, double *b, int *pn, int *pp)
{
	int i, k, j, n, p;     
	double sum;
	
	n=*pn;
	p=*pp;
	
	for (i=0; i<=n-1; i++){
		j=imax2(0,i-p);
		for (sum=b[i], k=i-1; k>=j; k--)  sum-=L[k*n+i]*x[k];
		if(L[i*n+i]==0.0)mexPrintf("Foward solve fail due to zero diagnonal.\n");
		x[i]=sum/L[i*n+i];
	}
}

void backward_sol_c(double *L, double *x, double *b, int *pn, int *pp)
{
	int i, k, j, n, p;
	
	double sum;
	
	n=*pn;p=*pp;
	
	for (i=n-1; i>=0; i--){
		j=imin2(n-1,i+p);
		for (sum=b[i], k=i+1; k<=j; k++)  sum-=L[i*n+k]*x[k];
		if(L[i*n+i]==0.0)mexPrintf("Backward solve fail due to zero diagnonal.\n");
		x[i]=sum/L[i*n+i];
	}
}


void mvrnorm(double *Q,  double *L, double *mu, int n, int p, double *x, long *idum)
/*generate x~N(u,Q);
pQ--Precision matrix in vector by column;
pL--Cholesky decomposition of Q with diagonal part;
mu--mean vector; 
pn--dimension of Q;  pp--bandwith of Q;*/
{
	int i, j;
	
	
	/*double z[NU];*/
	double *y;
	double tmp; 
	
	
	y=(double *) mxMalloc(sizeof(double) * n);
	
	
	band_choldc_c_mvrnorm(Q, L, &n, &p);
	/*Cholesky decompposition of matrix Q to be stored in L.*/
	/*backward_sol_c(L, x, z, &n, &p);*/
	/*Use Cholesky decomposition to solve t(L)v=z.*/
	
	for(i=0;i<n;i++){
		y[i]=gasdev(idum);
	}
	
	for(i=0;i<n;i++){
		tmp=0;
		for(j=0;j<=i;j++){
			tmp+=L[i+j*n]*y[j];
		}
		x[i]=mu[i]+tmp;		
	}
	
	mxFree(y);
	
	
}


double dmvnorm_L(double *x,  double *L, double *mu, double *tmp, double *tmp2, int n, int FLAG_log){
	double res=0;
	int j1;
	
	va_minus_vb(x,mu,tmp,n);
	
	forward_sol_c(L, tmp2, tmp, &n, &n);
	/*Use Cholesky decomposition to solve Lv=z.*/	
	
	res=vaT_mul_vb(tmp2,tmp2,n);
	res*=-0.5;
	
	for(j1=0;j1<n;j1++){
		res-=log(L[j1+j1*n]);		
	}
	if(FLAG_log==0){
		res = exp(res);
	}
	
	return res;
	
}



void Lindstrom_1step(double *Y, double *sdt_NR, double *para, double *a, double *b, double *mu, double *P, double *K, double *L, double *SIG, double *SIG0, double *y_new, double alpha, double *prop_loglike, double *Xcur, double *XVcur, int NRcurstep, int NLat, int NXV, int NR, int FL, int FLAG_gennew, int FLAT_callik, long *idum){
	/*
	*Y -- point to beginning of the bridge vector; length=(NR+2)*NLat; 0:(NLat-1) --begin node; (NR+1)*NLat:((NR+2)*NLat-1) -- end node;
	sdt_NR -- point to time of the beginning observation; length=(NR+3); 
	para -- point to parameter vector;
	a, b, mu -- point to vector with length NLat, auxilarry vectors;
	P, K, L, SIG, SIG0 -- pointer to vector of length NLat*NLat, auxillary matrix.
	alpha -- constant, the alpha in the algorithm provided in Lindstrom (2011)
	prop_loglike -- log likelihood of the 1 step proposal
	NRcurstep -- the location of the 1 step proposal to update, from 1 to NR
	NLat -- dimension of diffusion process
	NR -- number of interpolate points between begin and end points.
	FL -- flag, whether latent variable in observed time points are updated, NOT used currently.
	FLAG_gennew -- flag, whether the NRcurstep in the bridge is generated.
	FLAT_callik -- flag, whether the log likelihood of the 1 step proposal is calculated
	idum -- random seed
	*/
	int jN2, jN3;
	int kNLat1, kNLat2, kNLat3;
	int nNXV1;
	/*int n1;*/
	
	double dt1, dt2;
	double dtmp, dtmp1;
	double XVcur1;
	
	jN2 = NRcurstep;
	jN3 = jN2 * NLat;
	
	dt1 = (sdt_NR[jN2] - sdt_NR[jN2 - 1]);
	dt2 = (sdt_NR[NR + 1] - sdt_NR[jN2]); /*time difference between the ending point and the current point*/
	/*mexPrintf("dt: %f, %f;\n", dt1, dt2);			*/
	
	
	for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {
		/*to be check if the mu is good*/
		
		dtmp = drift_funa (Y + jN3 - NLat, para, Xcur, kNLat1, dt1, XVcur+(jN2-1)*NXV);
		dtmp1 = drift_funa (Y + jN3 - NLat, para, Xcur, kNLat1, dt2, XVcur+jN2*NXV);
		
		a[kNLat1] = Y[kNLat1 + jN3 - NLat] +  dtmp * dt1;
		b[kNLat1] = dtmp1 * dt2;
		mu[kNLat1] = Y[kNLat1 + (NR + 1) * NLat] - a[kNLat1] - b[kNLat1];
		/*mexPrintf("drift:%f, a:%f, mu:%f\n",dtmp,a[kNLat1],mu[kNLat1]);*/
		
		/*only consider diagonal structure here.*/
		for (kNLat2 = 0; kNLat2 < NLat; kNLat2++) {
			kNLat3 = kNLat2 * NLat;
			P[kNLat1+kNLat3] = 0;
			K[kNLat1+kNLat3] = 0;
			/*L[kNLat1+kNLat3] = 0; /*use for Q*/
			SIG0[kNLat1+kNLat3] = 0;
			
			if (kNLat2==kNLat1){
				dtmp = diffu_funa(Y + jN3 - NLat, para, Xcur, kNLat1, dt1, XVcur+(jN2-1)*NXV); /*dtmp is variance, not sd*/
				dtmp1 = diffu_funa(Y + jN3 - NLat, para, Xcur, kNLat1, dt2, XVcur+jN2*NXV);
				P[kNLat1+kNLat3] = dtmp * dt1;
				/*L[kNLat1+kNLat3] = dtmp1 * dt2;*/
				K[kNLat1+kNLat3] = dtmp * dt1 / (dtmp * dt1 + dtmp1 * dt2 + alpha * dtmp * dt2 * dt2 /dt1);/*dt1 / (dt1 + dt2 + alpha*dt2*dt2/dt1);*/
				SIG0[kNLat1+kNLat3] = 1;
			}
			SIG0[kNLat1+kNLat3] -= K[kNLat1+kNLat3];
		}
	}
	
	MA_mul_MB(SIG0, P, SIG, NLat, NLat, NLat);/*covariance matrix of multivariate normal proposal*/
	MA_mul_vb(K, mu, b, NLat, NLat);
	va_add_vb(a, b, mu, NLat);/*mean of multivariate normal proposal*/
	
	/*mexPrintf("K:\n");
	printmatrix(K,NLat,NLat);
	mexPrintf("P:\n");
	printmatrix(P,NLat,NLat);
	mexPrintf("SIG0:\n");
	printmatrix(SIG0,NLat,NLat);
	mexPrintf("SIG:\n");
	printmatrix(SIG,NLat,NLat);*/
	
	if(FLAG_gennew==1){				
		mvrnorm(SIG, L, mu, NLat, NLat, y_new, idum);
	}else{
		band_choldc_c(SIG, L, &NLat, &NLat);
		for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {  
			y_new[kNLat1] = Y[jN3 + kNLat1];
		}
	}
	
	/*printmatrix(SIG,NLat,NLat);*/
	
	if(FLAT_callik==1){
		*prop_loglike = dmvnorm_L(y_new, L, mu, a, b, NLat, 1);
	}
}

void Lindstrom_1step_obs(double *Y, double *sdt_NR, double *para, double *a, double *b, double *mu, double *P, double *K, double *L, double *SIG, double *SIG0, double *y_new, double alpha, double *prop_loglike, double *Xcur, double *XVcur, double *Z, double *Lamb, double *PSI, int NZ, int NRcurstep, int NLat, int NXV, int NR, int FL, int FLAG_gennew, int FLAT_callik, long *idum){
	/*
	*Y -- point to beginning of the bridge vector; length=(NR+2)*NLat; 0:(NLat-1) --begin node; (NR+1)*NLat:((NR+2)*NLat-1) -- end node;
	sdt_NR -- point to time of the beginning observation; length=(NR+3); 
	para -- point to parameter vector;
	a, b, mu -- point to vector with length NLat, auxilarry vectors;
	P, K, L, SIG, SIG0 -- pointer to vector of length NLat*NLat, auxillary matrix.
	alpha -- constant, the alpha in the algorithm provided in Lindstrom (2011)
	prop_loglike -- log likelihood of the 1 step proposal
	NRcurstep -- the location of the 1 step proposal to update, from 1 to NR
	NLat -- dimension of diffusion process
	NR -- number of interpolate points between begin and end points.
	FL -- flag, whether latent variable in observed time points are updated
	FLAG_gennew -- flag, whether the NRcurstep in the bridge is generated.
	FLAT_callik -- flag, whether the log likelihood of the 1 step proposal is calculated
	idum -- random seed
	*/
	int jN2, jN3;
	int kNLat1, kNLat2, kNLat3;
	int iNZ1;
	/*int n1;*/
	
	double dt1, dt2;
	double dtmp, dtmp1;
	
	double *M_NLat_NZ1;
	
	M_NLat_NZ1=(double *) mxMalloc(sizeof(double) * NZ * NLat);;
	
	jN2 = NRcurstep;
	jN3 = jN2 * NLat;
	
	dt1 = (sdt_NR[jN2] - sdt_NR[jN2 - 1]);
	dt2 = (sdt_NR[NR + 1] - sdt_NR[jN2]); /*time difference between the ending point and the current point*/
	/*mexPrintf("dt: %f, %f;\n", dt1, dt2);			*/
	
	
	
	for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {
		dtmp = drift_funa (Y + jN3 - NLat, para, Xcur, kNLat1,dt1,XVcur+(jN2-1)*NXV);
		dtmp1 = drift_funa (Y + jN3 - NLat, para, Xcur, kNLat1,dt2,XVcur+jN2*NXV);
		
		a[kNLat1] = Y[kNLat1 + jN3 - NLat] +  dtmp * dt1;
		mu[kNLat1] = Y[kNLat1 + (NR + 1) * NLat] - a[kNLat1] - dtmp1 * dt2;
		/*mexPrintf("drift:%f, a:%f, mu:%f\n",dtmp,a[kNLat1],mu[kNLat1]);*/
		
		/*only consider diagonal structure here.*/
		for (kNLat2 = 0; kNLat2 < NLat; kNLat2++) {
			kNLat3 = kNLat2 * NLat;
			P[kNLat1+kNLat3] = 0;
			K[kNLat1+kNLat3] = 0;
			SIG0[kNLat1+kNLat3] = 0;
			
			if (kNLat2==kNLat1){
				dtmp = diffu_funa(Y + jN3 - NLat, para, Xcur, kNLat1,dt1,XVcur+(jN2-1)*NXV); /*dtmp is variance, not sd*/
				dtmp1 = diffu_funa(Y + jN3 - NLat, para, Xcur, kNLat1,dt2,XVcur+jN2*NXV); /*dtmp is variance, not sd*/
				P[kNLat1+kNLat3] = dtmp * dt1;				
				K[kNLat1+kNLat3] = dtmp * dt1 / (dtmp * dt1 + dtmp1 * dt2 + alpha * dtmp * dt2 * dt2 /dt1);/*dt1 / (dt1 + dt2 + alpha*dt2*dt2/dt1);*/
				SIG0[kNLat1+kNLat3] = 1;
			}
			SIG0[kNLat1+kNLat3] -= K[kNLat1+kNLat3];
		}
	}
	
	MA_mul_MB(SIG0, P, SIG, NLat, NLat, NLat);/*covariance matrix of multivariate normal proposal*/
	MA_mul_vb(K, mu, b, NLat, NLat);
	va_add_vb(a, b, mu, NLat);/*mean of multivariate normal proposal*/
	
	ivv1(SIG,SIG0,NLat);
	
	for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {
		for(iNZ1=0;iNZ1<NZ;iNZ1++){
			M_NLat_NZ1[kNLat1+iNZ1*NLat]=Lamb[iNZ1+kNLat1*NZ]/PSI[iNZ1];
		}					
	}
	
	MA_mul_vb(SIG0,mu,b,NLat,NLat);
	MA_mul_vb(M_NLat_NZ1, Z, mu, NLat, NZ);
	
	va_add_vb(b, mu, a, NLat);
	
	MA_mul_MB(M_NLat_NZ1, Lamb, P, NLat, NLat, NZ);	
	MA_add_MB(P,SIG0,K,NLat,NLat);
	ivv2(K,SIG,NLat);
	
	MA_mul_vb(SIG,a,mu,NLat,NLat);
	
	if(FLAG_gennew==1){				
		mvrnorm(SIG, L, mu, NLat, NLat, y_new, idum);
	}else{
		band_choldc_c(SIG, L, &NLat, &NLat);
		for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {  
			y_new[kNLat1] = Y[jN3 + kNLat1];
		}
	}	
	
	if(FLAT_callik==1){
		*prop_loglike = dmvnorm_L(y_new, L, mu, a, b, NLat, 1);
	}
	
	mxFree(M_NLat_NZ1);	
	
}


void Lindstrom_1step_obs_endpoint(double *Y, double *sdt_NR, double *para, double *a, double *b, double *mu, double *P, double *K, double *L, double *SIG, double *SIG0, double *y_new, double alpha, double *prop_loglike, double *Xcur, double *XVcur,  double *Z, double *Lamb, double *PSI, int NZ, int NRcurstep, int NLat, int NXV, int NR,  int FL, int FLAG_gennew, int FLAT_callik, long *idum){
	/*
	*Y -- point to beginning of the bridge vector; length=(NR+2)*NLat; 0:(NLat-1) --begin node; (NR+1)*NLat:((NR+2)*NLat-1) -- end node;
	sdt_NR -- point to time of the beginning observation; length=(NR+3); 
	para -- point to parameter vector;
	a, b, mu -- point to vector with length NLat, auxilarry vectors;
	P, K, L, SIG, SIG0 -- pointer to vector of length NLat*NLat, auxillary matrix.
	alpha -- constant, the alpha in the algorithm provided in Lindstrom (2011)
	prop_loglike -- log likelihood of the 1 step proposal
	NRcurstep -- the location of the 1 step proposal to update, from 1 to NR
	NLat -- dimension of diffusion process
	NR -- number of interpolate points between begin and end points.
	FL -- flag, whether latent variable in observed time points are updated
	FLAG_gennew -- flag, whether the NRcurstep in the bridge is generated.
	FLAT_callik -- flag, whether the log likelihood of the 1 step proposal is calculated
	idum -- random seed
	*/
	int jN2, jN3;
	int kNLat1, kNLat2, kNLat3;
	int iNZ1;
	/*int n1;*/
	
	double dt1, dt2;
	double dtmp, dtmp1;
	
	double *M_NLat_NZ1;
	
	M_NLat_NZ1=(double *) mxMalloc(sizeof(double) * NZ * NLat);;
	
	jN2 = NRcurstep;
	jN3 = jN2 * NLat;
	
	dt1 = (sdt_NR[jN2] - sdt_NR[jN2 - 1]);
	/*dt2 = (sdt_NR[NR + 1] - sdt_NR[jN2]); /*time difference between the ending point and the current point*/
	/*mexPrintf("dt: %f, %f;\n", dt1, dt2);			*/	
	
	for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {                    
		dtmp = drift_funa(Y + jN3 - NLat, para, Xcur, kNLat1,dt1, XVcur+(jN2-1)*NXV);
		/*dtmp1 = drift_funa(Y + jN3 - NLat, para, Xcur, kNLat1,dt2);*/		
		
		mu[kNLat1] = Y[kNLat1 + jN3 - NLat] +  dtmp * dt1;
		/*mexPrintf("drift:%f, a:%f, mu:%f\n",dtmp,a[kNLat1],mu[kNLat1]);*/
		
		/*only consider diagonal structure here.*/			
		dtmp = diffu_funa(Y + jN3 - NLat, para, Xcur, kNLat1,dt1,XVcur+(jN2-1)*NXV); /*dtmp is variance, not sd*/
		SIG0[kNLat1 + kNLat1 * NLat] = 1 / (dtmp * dt1);			
		
	}					
	
	for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {
		for(iNZ1 = 0; iNZ1 < NZ; iNZ1++) {
			M_NLat_NZ1[kNLat1+iNZ1*NLat]=Lamb[iNZ1+kNLat1*NZ]/PSI[iNZ1];
		}					
	}
	
	MA_mul_vb(SIG0,mu,b,NLat,NLat);
	MA_mul_vb(M_NLat_NZ1, Z, mu, NLat, NZ);
	
	va_add_vb(b, mu, a, NLat);
	
	MA_mul_MB(M_NLat_NZ1, Lamb, P, NLat, NLat, NZ);	
	MA_add_MB(P,SIG0,K,NLat,NLat);
	ivv(K,SIG,NLat);
	
	MA_mul_vb(SIG,a,mu,NLat,NLat);
	
	if(FLAG_gennew==1){				
		mvrnorm(SIG, L, mu, NLat, NLat, y_new, idum);
	}else{
		band_choldc_c(SIG, L, &NLat, &NLat);
		for (kNLat1 = 0; kNLat1 < NLat; kNLat1++) {  
			y_new[kNLat1] = Y[jN3 + kNLat1];
		}
	}	
	
	if(FLAT_callik==1){
		*prop_loglike = dmvnorm_L(y_new, L, mu, a, b, NLat, 1);
	}
	
	mxFree(M_NLat_NZ1);	
	
}



double EM_diagcov(double *Y, double *sdt_NR, double *para, double *Xcur, double *XVcur,  int Nlen, int NLat, int NXV){
	
	int kLat1;
	int jN1;
	double loglike=0;
	double dtmp, dtmp1, dtmp2;
	
	for(jN1=1;jN1<Nlen;jN1++){
		for(kLat1=0;kLat1<NLat;kLat1++){	
			dtmp=(sdt_NR[jN1]-sdt_NR[jN1-1]);
			dtmp1=diffu_funa(Y + (jN1-1)*NLat, para,  Xcur, kLat1, dtmp, XVcur+(jN1-1)*NXV)*dtmp;
			
			loglike+=log(dtmp1);
			
			dtmp2=(Y[jN1*NLat+kLat1]-Y[(jN1-1)*NLat+kLat1]-drift_funa(Y + (jN1-1)*NLat, para, Xcur, kLat1,dtmp,XVcur+(jN1-1)*NXV)*dtmp);
			loglike+=dtmp2*dtmp2/dtmp1;
		}
	}
	loglike*=(-0.5);
	
	return loglike;
}


double ME_loglik(double *Zvec, double *mu, double *Lamb, double *Y, double *SIG, int NZ, int NLat){
	int jNZ1, kNLat1;
	double dtmp1, logr;
	
	logr=0.0;
	for (jNZ1=0;jNZ1<NZ;jNZ1++)
	{
                dtmp1=Zvec[jNZ1];
                for (kNLat1=0;kNLat1<NLat;kNLat1++){
                	dtmp1-=Lamb[jNZ1+kNLat1*NZ]*Y[kNLat1];
                }
                logr-=dtmp1*dtmp1/(2*SIG[jNZ1]);
        }	
        
	return logr;
}




void MA_mul_MB(double *A, double *B, double *C, int NAR, int NBC, int NAC){
	
	int k1, k2, k3;
	
	for (k1 = 0; k1 < NAR; k1++) {
		for (k2 = 0; k2 < NBC; k2++) {	
			C[k1+k2*NAR] = 0;
			for (k3 = 0; k3 < NAC; k3++) {
				C[k1+k2*NAR] += A[k1+k3*NAR] * B[k3+k2*NAC];
			}
		}
	}
	
}

void MA_add_MB(double *A, double *B, double *C, int NAR, int NAC){
	
	int k1, k2, k3;
	k3=0;
	for (k2 = 0; k2 < NAC; k2++) {									
		for (k1 = 0; k1 < NAR; k1++) {						
			C[k3] = A[k3] + B[k3];
			k3++;
		}
	}
}

void MA_min_MB(double *A, double *B, double *C, int NAR, int NAC){
	
	int k1, k2, k3;
	k3=0;
	for (k2 = 0; k2 < NAC; k2++) {									
		for (k1 = 0; k1 < NAR; k1++) {						
			C[k3] = A[k3] - B[k3];
			k3++;
		}
	}
}



void MB_mul_MA_mul_MBt(double *A, double *B, double *C, int NBR, int NBC){
	
	int k1, k2, k3, k4;
	double tmp;
	
	for (k2 = 0; k2 < NBR; k2++) {									
		for (k1 = 0; k1 < NBR; k1++) {										
			tmp=0;
			for (k3 = 0; k3 < NBC; k3++) {										
				for (k4 = 0; k4 < NBC; k4++) {										
					tmp+=B[k1+k3*NBR]*A[k3+k4*NBC]*B[k2+k4*NBR];									
				}
			}
			C[k1+k2*NBR]=tmp;
		}
	}
	
}

void MBt_mul_MB(double *B, double *C, int NBR, int NBC){
	
	int k1, k2, k3;
	double tmp;
	
	for (k2 = 0; k2 < NBC; k2++) {									
		for (k1 = 0; k1 < NBC; k1++) {										
			tmp=0;
			for (k3 = 0; k3 < NBR; k3++) {																									
				tmp+=B[k3+k1*NBR]*B[k3+k2*NBR];														
			}
			C[k1+k2*NBR]=tmp;
		}
	}
	
}

void MA_mul_MBt(double *A, double *B, double *C, int NAR, int NBR, int NAC){
	
	int k1, k2, k3;
	
	for (k1 = 0; k1 < NAR; k1++) {
		for (k2 = 0; k2 < NBR; k2++) {	
			C[k1+k2*NAR] = 0;
			for (k3 = 0; k3 < NAC; k3++) {
				C[k1+k2*NAR] += A[k1+k3*NAR] * B[k2+k3*NAC];
			}
		}
	}
	
}

void MA_mul_vb(double *A, double *b, double *c, int NAR, int NAC){
	
	int k1, k2;
	
	for (k1 = 0; k1 < NAR; k1++) {
		c[k1] = 0;
		for (k2 = 0; k2 < NAC; k2++) {	
			c[k1] += A[k1+k2*NAR] * b[k2];
		}
	}
}


void va_add_vb(double *a, double *b, double *c, int NAR){
	
	int k1;
	for (k1 = 0; k1 < NAR; k1++) {
		c[k1] = a[k1] + b[k1];
	}
}				

void va_minus_vb(double *a, double *b, double *c, int NAR){
	
	int k1;
	for (k1 = 0; k1 < NAR; k1++) {
		c[k1] = a[k1] - b[k1];
	}
}				


double vaT_mul_vb(double *a, double *b, int NAR){
	
	int k1;
	double res=0;
	for (k1 = 0; k1 < NAR; k1++) {			
		res += a[k1] * b[k1];
	}
	return res;
}

double vaT_M_vb(double *a, double *M, double *b, int NAR){
	
	int k1, k2, k3;
	double res=0;
	for (k2 = 0; k2 < NAR; k2++) {
		k3=k2*NAR;
		for (k1 = 0; k1 < NAR; k1++) {								
			res += a[k1] * M[k1+k3] * b[k2];
		}
	}
	return res;
}

void vb_eqn_va(double *a, double *b, int NAR){
	int k1;
	
	for (k1 = 0; k1 < NAR; k1++) {					
		b[k1] = a[k1];
	}
}	



void cumsum(double *a, double *cs, int len){
	int j1;
	
	for(j1=0;j1<len;j1++){
		if(j1==0){
			cs[j1]=0;
		} else {
			cs[j1]=cs[j1-1]+a[j1-1];
		}		
	}
	cs[len]=cs[len-1]+a[len-1];
}

void printmatrix(double *M, int NR, int NC){
	
	int i, j;
	
	for(i=0;i<NR;i++){
		for(j=0;j<NC;j++){
			mexPrintf("%f, ",M[i+j*NR]);
		}
		mexPrintf("\n");
	}
	mexPrintf("\n");
}

void printfilematrix(double *M, int NR, int NC){
	
	int i, j;
	FILE *dat;
	
	dat=fopen("printfilem.txt", "a");
	for(i=0;i<NR;i++){
		for(j=0;j<NC;j++){
			fprintf(dat,"%f, ",M[i+j*NR]);
		}
		fprintf(dat,"\n");
	}
	fprintf(dat,"\n");
	fclose(dat);
}


void printvector(double *v, int NR){
	
	int i;
	
	for(i=0;i<NR;i++){		
		mexPrintf("%f, ",v[i]);		
	}
	mexPrintf("\n");
}


void  ivv(double *W, double *IW, int NT)
{
	int  i, k;       
	double  *col, *col2;
	double *L, *L2;
        
	col=(double *)mxMalloc(sizeof(double)*(NT));
	col2=(double *)mxMalloc(sizeof(double)*(NT));
	L=(double *)mxMalloc(sizeof(double)*(NT*NT));
	L2=(double *)mxMalloc(sizeof(double)*(NT*NT));      
	
	band_choldc_c_ivv(W, L, &NT, &NT);
	
	for(k=0;k<NT;k++){
		for(i=0;i<NT;i++)
			col[i]=0.0;
		col[k]=1.0;
		forward_sol_c(L, col2, col, &NT, &NT);	    
		for(i=0; i<NT;i++)  L2[i+k*NT]=col2[i];
	}
	
	MBt_mul_MB(L2, IW, NT, NT);
	
	mxFree(L2);
	mxFree(L);
	mxFree(col2);
	mxFree(col);
	
}/* end of inver.c */


void  ivv1(double *W, double *IW, int NT)
{
	int  i, k;       
	double  *col, *col2;
	double *L, *L2;
        
	col=(double *)mxMalloc(sizeof(double)*(NT));
	col2=(double *)mxMalloc(sizeof(double)*(NT));
	L=(double *)mxMalloc(sizeof(double)*(NT*NT));
	L2=(double *)mxMalloc(sizeof(double)*(NT*NT));      
	
	band_choldc_c_ivv1(W, L, &NT, &NT);
	
	for(k=0;k<NT;k++){
		for(i=0;i<NT;i++)
			col[i]=0.0;
		col[k]=1.0;
		forward_sol_c(L, col2, col, &NT, &NT);	    
		for(i=0; i<NT;i++)  L2[i+k*NT]=col2[i];
	}
	
	MBt_mul_MB(L2, IW, NT, NT);
	
	mxFree(L2);
	mxFree(L);
	mxFree(col2);
	mxFree(col);
	
}/* end of inver.c */


void  ivv2(double *W, double *IW, int NT)
{
	int  i, k;       
	double  *col, *col2;
	double *L, *L2;
        
	col=(double *)mxMalloc(sizeof(double)*(NT));
	col2=(double *)mxMalloc(sizeof(double)*(NT));
	L=(double *)mxMalloc(sizeof(double)*(NT*NT));
	L2=(double *)mxMalloc(sizeof(double)*(NT*NT));      
	
	band_choldc_c_ivv2(W, L, &NT, &NT);
	
	for(k=0;k<NT;k++){
		for(i=0;i<NT;i++)
			col[i]=0.0;
		col[k]=1.0;
		forward_sol_c(L, col2, col, &NT, &NT);	    
		for(i=0; i<NT;i++)  L2[i+k*NT]=col2[i];
	}
	
	MBt_mul_MB(L2, IW, NT, NT);
	
	mxFree(L2);
	mxFree(L);
	mxFree(col2);
	mxFree(col);
	
}/* end of inver.c */


void rnorm_prec(double *Q, double *L, double *u, double *x, int n, int p, long *idum)
/*generate x~N(u,Q^-1) from RUE p.38 algorithm 2.6;
pQ--Precision matrix in vector by column;
pL--Cholesky decomposition of Q with diagonal part;
mu--mean vector; pA--constrain matrix with each row a constrain;
pe--vector e used as pA%*%x=pe;
pn--dimension of Q;  pp--bandwith of Q; pnc--# of constraint=# of rows of A*/
{
	int i;
	
	/*double z[NU];*/
	double *z;
	
	z=(double *) mxMalloc(sizeof(double) * n);
	
	for(i=0;i<n;i++)z[i]=gasdev(idum);
	band_choldc_c(Q, L, &n, &p);
	/*Cholesky decompposition of matrix Q to be stored in L.*/
	backward_sol_c(L, x, z, &n, &p);
	/*Use Cholesky decomposition to solve t(L)v=z.*/
	for(i=0;i<n;i++){
		x[i]+=u[i];
		/*v~N(u,t(L)-1L-1)=N(u,Q^-1))*/
		/*Rprintf("%f,",v[i]);*/
	}
	
	mxFree(z);
	
}


void rnorm_precL(double *L, double *u, double *x, int n, int p, long *idum)
/*generate x~N(u,Q^-1) from RUE p.38 algorithm 2.6;
pQ--Precision matrix in vector by column;
pL--Cholesky decomposition of Q with diagonal part;
mu--mean vector; pA--constrain matrix with each row a constrain;
pe--vector e used as pA%*%x=pe;
pn--dimension of Q;  pp--bandwith of Q; pnc--# of constraint=# of rows of A*/
{
	int i;
	
	/*double z[NU];*/
	double *z;
	
	z=(double *) mxMalloc(sizeof(double) * n);
	
	for(i=0;i<n;i++)z[i]=gasdev(idum);     
	/*Cholesky decompposition of matrix Q to be stored in L.*/
	backward_sol_c(L, x, z, &n, &p);
	/*Use Cholesky decomposition to solve t(L)v=z.*/
	for(i=0;i<n;i++){
		x[i]+=u[i];
		/*v~N(u,t(L)-1L-1)=N(u,Q^-1))*/
		/*Rprintf("%f,",v[i]);*/
	}
	
	mxFree(z);
	
}



int lm_rep2_coef_expxbeta_mh(double *z, double *w, double *x, double *bet, double *bet0, double *betm, double *betiSig, double psd, int NObs, int N0, int NR, int *N0_ALL, int NX, long *idum)
/*
z- a vector of response variables in repeat measured, univariate
w- a vector of covariate in repeat measured, univariate
x- a vecto of covariates to form the subject specific regression coefficient exp(x^T\beta)
(x1',x2',...,xn')'
bet- a vector of current regression coefficients
length of NX+1, including a intercept at location NX.
bet0- a vector of regression coefficients at which hessian matrix is calculated
length of NX+1, including a intercept at location NX.
psd- error variance
NObs- # of subjects
N0- maximum # of measurements accross all subjects.
NR- # of inserted points between two observed time points.
N0_ALL- a vector of # of measurement of all subjects
NX- length of x1'.
*/
{
	int i1=0, i2, i3;
	int j1, j2;
	int L1;
	
	int N10, NX2;
	
	double *SIG, *L, *bet1, *bet2;
	double sum1, sum2, sum3, sum4;
	double dtmp1, dtmp2, dtmp;
	double scalep;
	
	int NX1;
	int itmp;
	
	NX1=NX+1;
	
	SIG=(double *) mxMalloc(sizeof(double) * NX1 * NX1);
	L=(double *) mxMalloc(sizeof(double) * NX1 * NX1);
	bet1=(double *) mxMalloc(sizeof(double) * NX1);
	bet2=(double *) mxMalloc(sizeof(double) * NX1);
	
	
	
	
	NX2=NX1*NX1;
	
	for(j1=0;j1<NX2;j1++){
		SIG[j1]=0;
	}
	
	N10=N0*(NR+1);
	
	sum1=0;sum2=0;
	
	/*mexPrintf("In lm_rep2_coef_expxbeta_mh\n");*/
	
	for(i1=0;i1<NObs;i1++){
		L1=N0_ALL[i1]*(NR+1);
		sum3=0;
		sum4=0;
		i2=i1*N10;
		i3=i1*NX;
		for(j1=0;j1<L1;j1++){
			j2=i2+j1;
			sum3+=z[j2]*w[j2];
			sum4+=w[j2]*w[j2];
		}
		dtmp1=bet0[NX];
		/*mexPrintf("bet0 = %f, cumsum = %f\n",bet0[NX],dtmp1);*/
		for(j1=0;j1<NX;j1++){
			dtmp1+=x[i3+j1]*bet0[j1];
			/*mexPrintf("bet%d = %f, cumsum = %f\n",j1+1,bet0[NX],dtmp1);*/
		}
		/*mexPrintf("(xt*beta) = %f\n",dtmp1);*/
		dtmp1=exp(dtmp1);
		/*mexPrintf("exp(xt*beta) = %f\n",dtmp1);*/
		
		/*mexPrintf("sum3 = %f\n",sum3);
		mexPrintf("sum4 = %f\n",sum4);*/
		
		sum3*=dtmp1;
		
		sum4*=2;
		sum4*=dtmp1;
		sum4*=dtmp1;
		
		sum4-=sum3;
		sum4/=psd;
		
		/*mexPrintf("sum4 = %f\n",sum4);*/
		
		for(j1=0;j1<NX;j1++){
			for(j2=j1;j2<NX;j2++){			
				SIG[j1+j2*NX1]+=x[i3+j1]*x[i3+j2]*sum4;
			}
		}
		j2=NX;
		for(j1=0;j1<NX;j1++){
			SIG[j1+j2*NX1]+=x[i3+j1]*sum4;
		}
		j1=NX;
		SIG[j1+j2*NX1]+=sum4;
		
		/*mexPrintf("SIG at NObs = %d\n",i1);
		for(j1=0;j1<NX1;j1++){
		for(j2=0;j2<NX1;j2++){			
		mexPrintf("%f ",SIG[j1+j2*NX1]);
		}
		mexPrintf("\n");
		}*/
	}
	
	for(j1=0;j1<NX1;j1++){
		for(j2=0;j2<j1;j2++){			
			SIG[j1+j2*NX1]=SIG[j2+j1*NX1];
		}
	}
	
	scalep=1;/*10.0;*/
	
	for(j1=0;j1<NX1;j1++){
		for(j2=0;j2<NX1;j2++){			
			SIG[j1+j2*NX1]*=scalep;
		}
	}
	
	/*printmatrix(SIG,NX1,NX1);*/
	
	
	
	/*SIG[0]=1;SIG[1]=0.3;SIG[2]=0.3;	
	SIG[3]=0.3;SIG[4]=1;SIG[5]=0.3;	
	SIG[6]=0.3;SIG[7]=0.3;SIG[8]=1;	*/
	
	itmp = 0;
	for(j1=0;j1<NX1;j1++){
		if(SIG[j1+j1*NX1]<=0){
			itmp=1;
			break;
		}
	}
	
	if(itmp==1){
		dtmp1=0;
		for(j1=0;j1<NX1;j1++){
			dtmp1 += abs(SIG[j1+j1*NX1]);
		}
		dtmp1/=NX1;
		
		for(j1=0;j1<NX1;j1++){
			for(j2=0;j2<NX1;j2++){			
				SIG[j1+j2*NX1]=0;
			}
			SIG[j1+j1*NX1]=dtmp1;
		}
	}
	
	/*mexPrintf("SIG %d:\n",itmp);
	for(j1=0;j1<NX1;j1++){
	for(j2=0;j2<NX1;j2++){			
	mexPrintf("%f ",SIG[j1+j2*NX1]);
	}
	mexPrintf("\n");
	}*/
	
	itmp=band_choldc_c_ind(SIG, L, &NX1, &NX1);
	/*mexPrintf("band_choldc_c_ind, %d\n",itmp);
	mexPrintf("L at NObs = %d\n",i1);
	for(j1=0;j1<NX1;j1++){
	for(j2=0;j2<NX1;j2++){			
	mexPrintf("%f ",L[j1+j2*NX1]);
	}
	mexPrintf("\n");
	}*/
	
	/*if(itmp==1){
	dtmp1=0;
	for(j1=0;j1<NX1;j1++){
	dtmp1+=abs(SIG[j1+j1*NX1]);
	}
	dtmp1/=NX1;
	
	for(j1=0;j1<NX1;j1++){
	for(j2=0;j2<NX1;j2++){			
	L[j1+j2*NX1]=0.0;
	}
	L[j1+j1*NX1]=sqrt(dtmp1);
	}		
	}*/
	
	/*for(j1=0;j1<NX1;j1++){
	for(j2=0;j2<NX1;j2++){			
	mexPrintf("%f ", L[j1+j2*NX1]);
	}			
	mexPrintf("\n");
	}*/
	
	rnorm_precL(L,bet,bet1,NX1,NX1,idum);
	/*void rnorm_prec(double *Q, double *L, double *u, double *x, int n, int p)*/
	
	/*printmatrix(bet1,NX1,1);*/
	
	
	sum3=0;sum4=0;
	for(i1=0;i1<NObs;i1++){
		L1=N0_ALL[i1]*(NR+1);
		i2=i1*N10;
		i3=i1*NX;
		
		dtmp1=bet1[NX];
		dtmp2=bet[NX];
		for(j1=0;j1<NX;j1++){
			dtmp1+=x[i3+j1]*bet1[j1];
			dtmp2+=x[i3+j1]*bet[j1];
		}
		dtmp1=exp(dtmp1);
		dtmp2=exp(dtmp2);
		
		for(j1=0;j1<L1;j1++){
			j2=i2+j1;
			
			dtmp=z[j2]-dtmp1*w[j2];
			sum3+=dtmp*dtmp;
			
			dtmp=z[j2]-dtmp2*w[j2];
			sum4+=dtmp*dtmp;
		}
	}
	
	sum1=(sum3-sum4)/psd;
	
	va_minus_vb(bet1, betm, bet2, NX1);
	sum1+=vaT_M_vb(bet2, betiSig, bet2, NX1);
	
	va_minus_vb(bet, betm, bet2, NX1);
	sum1-=vaT_M_vb(bet2, betiSig, bet2, NX1);
	
	sum1*=-0.5;
	
	i1=0;
	if(ran2(idum)<=sum1){
		vb_eqn_va(bet1,bet,NX1);
		i1=1;
	}
	
	mxFree(bet2);
	mxFree(bet1);
	mxFree(L);
	mxFree(SIG);
	
	return i1;
}




int which_max(double *a, int p){
	int i1;
	int itmp = 0;
	int dtmp = a[0];
	
	for(i1=1;i1<p;i1++){
		if(a[i1]>dtmp){
			dtmp = a[i1];
			itmp = i1;
		}
	}
	return itmp;
}


void submatrix1(double *M, double *S, int dM, int *idx, int nidx){
	int i1, i2;
	
	for(i1=0;i1<nidx;i1++){
		for(i2=0;i2<nidx;i2++){
			S[i1+i2*nidx] = M[idx[i1] + idx[i2]*dM];
		}
	}
}

void subvector1(double *M, double *S, int *idx, int nidx){
	int i1;
	
	for(i1=0;i1<nidx;i1++){
		S[i1] = M[idx[i1]];
	}
}

void initializ_MA(double *A, int NAR, int NAC){
	
	int k1, k2, k3;
	k3=0;
	for (k2 = 0; k2 < NAC; k2++) {									
		for (k1 = 0; k1 < NAR; k1++) {						
			A[k3] = 0;
			k3++;
		}
	}
}



void initializ_iMA(int *A, int NAR, int NAC){
	
	int k1, k2, k3;
	k3=0;
	for (k2 = 0; k2 < NAC; k2++) {									
		for (k1 = 0; k1 < NAR; k1++) {						
			A[k3] = 0;
			k3++;
		}
	}
}

void rowMeans(double *Ep, double *Emp, int nr, int nc){
	int i1, i2;
	
	for(i1 = 0;i1<nr;i1++){
		Emp[i1] = 0;
	}
	
	for(i1 = 0;i1<nr;i1++){
		for(i2=0; i2<nc; i2++){
			Emp[i1] += Ep[i1 + i2 * nr];
		}
	}
	
	for(i1 = 0;i1<nr;i1++){
		Emp[i1] /= nc;
	}
}









